var grilleVisible=true;
var damier=[];
var borderless=false;
var nbCasesVides=0;

function verifieDepasseLimitesEnv () {
	if (nbMaxInd==0) {return false;}
	var n=0;
	for (let ent of tEnt) {
		if (ent.modePla=="manu") {
			n+=ent.tPla.length/2;
		} else {
			n+=ent.nbInd;
		}
	}
	if (n>nbMaxInd) {
		var oldN=nbMaxInd;
		nbMaxInd=n;
		Swal({
		  type: 'info',
		  title: 'Augmentation du nombre maximal d\'agents',
		  html: 'Le nombre initial d\'agents dépasse la limite ('+oldN+') saisie dans le panneau \"Environnement\".<br><br>Cette limite a été augmentée (nouvelle valeur : '+n+').'
		})
	}
}

function compteCasesVides () {
	nbCasesVides=nbLig*nbCol;
	for (let e of tEnt) {
		nbCasesVides-=e.tInd.length;
	}
}

function traceGrille() {
	var canv=byId("canvGrille");
	var ctx=canv.getContext('2d');
	ctx.clearRect(0,0,lCanv,hCanv);
	ctx.strokeStyle="rgba(0,0,0,0.07)";
	
	if (grilleVisible) {
		ctx.beginPath();
		for (let i=0;i<=nbCol;i++) {
			let x=(lCanv-1)*(i/(nbCol))+0.5;
			
			ctx.moveTo(x,0);
			ctx.lineTo(x,hCanv);
		}
		for (let j=0;j<=nbLig;j++) {
			
			let y=(hCanv-1)*(j/(nbLig))+0.5;
			
			ctx.moveTo(0,y);
			ctx.lineTo(lCanv,y);
			
		}
		ctx.stroke();
	} else {
		ctx.strokeRect(0,0,lCanv,hCanv);
	}

}

function afficheGrille(c) {
	grilleVisible=c;
	 traceGrille();
}

function updateLigCol () {
	byId("inputNbLig").value=nbLig;
	byId("inputNbCol").value=nbCol;
	byId("inputNbMaxEnt").value=nbMaxInd;
	byId("checkBorderless").checked=borderless;
	compteCasesVides ();
}

function clickEditEnvt () {
	updateLigCol();
	hasImageBGChanged=false;
	affModale('divSaisieXY');
}




function butOKsaisieXY () {
	imageBGSelected();
	
	var l=byId("inputNbLig").value*1;
	var c=byId("inputNbCol").value*1;
	var mini=byId("inputNbLig").min*1;
	var maxi=byId("inputNbLig").max*1;
	if (l>maxi) {l=maxi}
	if (c>maxi) {c=maxi}
	if (l<mini) {l=mini}
	if (c<mini) {c=mini}
	
	doResetAnim();
	nbLig=l;
	nbCol=c;
	if (damierZ.length>0) {
		if ((damierZ.length!=nbLig)||(damierZ[0].length!=nbCol)) {
			// il faut réinitialiser le damier des zones
			initDamierZone();
		}
	}
	nbMaxInd=byId("inputNbMaxEnt").value*1;
	borderless=byId("checkBorderless").checked;
	opaZone=byId("inputOpaZones").value*1;
	
	elimineTPlaHorsLimite();
	updateLigCol ();
	cacheModale();
	hideId("divSaisieXY");
	repeupleTout();
	redimGrille();
	positionneEnvt();
	traceZones();
}

function initDamierZone () {
	damierZ=[];
	damierZ0=[];
	for (var i=0;i<nbCol;i++) {
		damierZ[i]=[];
		damierZ0[i]=[];
		for (var j=0;j<nbLig;j++) {
			damierZ[i][j]=0;
			damierZ0[i][j]=0;
		}
	}	
}

function initDamier() {
	damier=[];
	for (var i=0;i<nbCol;i++) {
		damier[i]=[];
		for (var j=0;j<nbLig;j++) {
			damier[i][j]=0;
		}
	}	
	compteCasesVides ();
}

function updateDamier () {
	initDamier();	
	for (var ent of tEnt) {
		var id=ent.id;
		for (var ind of ent.tInd) {
			damier[ind.x][ind.y]=id;
		}
	}
	compteCasesVides ();
}



function redimGrille () {	
	lCanv=nbCol*100;
	hCanv=nbLig*100;
	var ratio=lCanv/hCanv;
	var hHeader=divDamierHeader.getBoundingClientRect().height;
	
	var l=lMain*0.98;
	var h=hMain*0.98;
	
	while ((lCanv>l)||((hCanv+hHeader)>h)) {
		lCanv*=0.99;
		hCanv=lCanv/ratio;
	}
	
	lCanv=Math.floor(lCanv);
	hCanv=Math.floor(hCanv);
	
	
	byId("divCanv").style.height=hCanv+"px";
	byId("divCanv").style.width=lCanv+"px";
	
	var canv=byId("canvGrille");
	canv.width=lCanv;
	canv.height=hCanv;
	canv.style.width=lCanv+"px";
	canv.style.height=hCanv+"px";
	var ctx=canv.getContext('2d');
	ctx.fillStyle="red";
	ctx.fillRect(0,0,lCanv,hCanv);
	
	var canv=byId("canvEnv");
	canv.width=lCanv;
	canv.height=hCanv;
	canv.style.width=lCanv+"px";
	canv.style.height=hCanv+"px";
	var ctx=canv.getContext('2d');
	ctx.clearRect(0,0,lCanv,hCanv);
	
	var canv=byId("canvZones");
	canv.width=lCanv;
	canv.height=hCanv;
	canv.style.width=lCanv+"px";
	canv.style.height=hCanv+"px";
	var ctx=canv.getContext('2d');
	ctx.clearRect(0,0,lCanv,hCanv);
	
	var canv=byId("canvBG");
	canv.width=lCanv;
	canv.height=hCanv;
	canv.style.width=lCanv+"px";
	canv.style.height=hCanv+"px";
	var ctx=canv.getContext('2d');
	// tracé du fond
	if (hasImageBG) {
		var canvBG=byId("canvTemp64BG");
		var ctxBG=canvBG.getContext('2d');
		ctx.drawImage(canvBG,0,0,512,512,0,0,lCanv,hCanv);
	} else {
		ctx.fillStyle="white";
		ctx.fillRect(0,0,lCanv,hCanv);
	}
	
	traceGrille();
	traceZones();
	traceEntites();
}

function positionneEnvt () {
	var hHeader=divDamierHeader.getBoundingClientRect().height;
	var bGraph=byId("divGraphique").getBoundingClientRect();
	var boxCont=byId("panneauCentre").getBoundingClientRect();
	var lRestant=lMain-bGraph.width-lCanv-bGraph.x+boxCont.x;
	var xMax=boxCont.width-lCanv-2;
	byId("divDamier").style.top=(hMain-hCanv-hHeader)/2+"px";
	var x=bGraph.x+bGraph.width-boxCont.x+lRestant/2;
	if (x>xMax) {x=xMax;}
	byId("divDamier").style.left=x+"px";
}




function placesLibresAutourDe(x,y) {
	
	var libres=[];
	var xx,yy;
	
	if (damier[x][y]==0) {
		libres.push({x:x,y:y});
	}

	xx=x+1;
	yy=y;
	if ((xx>=0)&&(xx<nbCol)&&(yy>=0)&&(yy<nbLig)) {
			if (damier[xx][yy]==0) {
				libres.push({x:xx,y:yy});
			}
	}
	
	xx=x-1;
	yy=y;
	if ((xx>=0)&&(xx<nbCol)&&(yy>=0)&&(yy<nbLig)) {
			if (damier[xx][yy]==0) {
				libres.push({x:xx,y:yy});
			}
	}
	
	xx=x;
	yy=y+1;
	if ((xx>=0)&&(xx<nbCol)&&(yy>=0)&&(yy<nbLig)) {
			if (damier[xx][yy]==0) {
				libres.push({x:xx,y:yy});
			}
	}
	
	xx=x;
	yy=y-1;
	if ((xx>=0)&&(xx<nbCol)&&(yy>=0)&&(yy<nbLig)) {
			if (damier[xx][yy]==0) {
				libres.push({x:xx,y:yy});
			}
	}
	return libres;
}

function voisinsAutourDe(x,y) {
	// x y compris
	var voisins=[];
	var xx,yy;
	
	xx=x;
	yy=y;
	if ((xx>=0)&&(xx<nbCol)&&(yy>=0)&&(yy<nbLig)) {
		voisins.push({x:xx,y:yy,id:damier[xx][yy]});
	}
	
	xx=x+1;
	yy=y;
	if ((xx>=0)&&(xx<nbCol)&&(yy>=0)&&(yy<nbLig)) {
		voisins.push({x:xx,y:yy,id:damier[xx][yy]});
	}

	xx=x-1;
	yy=y;
	if ((xx>=0)&&(xx<nbCol)&&(yy>=0)&&(yy<nbLig)) {
		voisins.push({x:xx,y:yy,id:damier[xx][yy]});
	}	
	
	xx=x;
	yy=y+1;
	if ((xx>=0)&&(xx<nbCol)&&(yy>=0)&&(yy<nbLig)) {
		voisins.push({x:xx,y:yy,id:damier[xx][yy]});
	}	
	
	xx=x;
	yy=y-1;
	if ((xx>=0)&&(xx<nbCol)&&(yy>=0)&&(yy<nbLig)) {
		voisins.push({x:xx,y:yy,id:damier[xx][yy]});
	}	
	
	return voisins;
}



function findCaseVide () {
	var t=[];
	var c={x:-1,y:-1};
	for (let x=0;x<damier.length;x++) {
		let d=damier[x];
		for (let y=0;y<d.length;y++) {
			if (d[y]==0) {
				t.push({x:x,y:y});
			}
		}
	}
	let l=t.length;
	if (l>0) {
		let i=Math.floor(Math.random()*t.length);
		c=t[i];
	}
	return c;
}

function findCaseVideZone (z) {
	if (z<0) {return findCaseVide()} else {
		var t=[];
		var c={x:-1,y:-1};
		for (let x=0;x<damier.length;x++) {
			let d=damier[x];
			let dz=damierZ[x];
			for (let y=0;y<d.length;y++) {
				if ((d[y]==0)&&(dz[y]==z)) {
					t.push({x:x,y:y});
				}
			}
		}
		let l=t.length;
		if (l>0) {
			let i=Math.floor(Math.random()*t.length);
			c=t[i];
		}
		return c;
	}
}


