var hasImageBG=false;
var hasImageBGChanged=false;

function selectApparenceChange(v) {
	hideId("divChangeImage");
	if (v=="image") {
		imageIsSelected();
		byId("divChangeImage").style.display="inline-block";
	}
	if (v=="carac") {
		showId("divChoixCaractere");
		byId("inputCaract").value="#";
	} else {
		hideId("divChoixCaractere");
	}
}

function imageIsSelected() {
	showId("divChoixImage");
	hideId("divSaisieEntite");
	var src="";
	if (selectedAgent<0) {
		src="";
	}	
	else if (typeof (entById(selectedAgent).png64)==="undefined") {
		src="";
	} else {
		src=entById(selectedAgent).png64;
	}
	byId("imgPreview").src=src;
}

function imageSelectedOK() {
	hideId("divChoixImage");
	showId("divSaisieEntite");
		
	var canv=byId("canvTemp64");
	var ctx=canv.getContext('2d');
	ctx.clearRect(0,0,32,32);
	var img=byId("imgPreview");
	var large=img.naturalWidth;
	var haut=img.naturalHeight;
	var ratio=large/haut;
	if (large>haut) {
		var largeC=32;
		var hautC=Math.floor(largeC/ratio);
	} else {
		var hautC=32;
		var largeC=Math.floor(hautC*ratio);
	}
		
	ctx.drawImage(img,0,0,large,haut,0,0,largeC,hautC);
}

function imageBGSelected() {
	if (!hasImageBGChanged) {return false}
	var canv=byId("canvTemp64BG");
	var ctx=canv.getContext('2d');
	ctx.clearRect(0,0,512,512);
	var img=byId("imgPreviewBG");
	var large=img.naturalWidth;
	var haut=img.naturalHeight;
	var ratio=large/haut;
	if (large>haut) {
		var largeC=512;
		var hautC=Math.floor(largeC/ratio);
	} else {
		var hautC=512;
		var largeC=Math.floor(hautC*ratio);
	}
		
	ctx.drawImage(img,0,0,large,haut,0,0,largeC,hautC);
	hasImageBG=true;
}

function loadPreview () {
	var file=byId("imageFileApi").files[0];;
	var reader  = new FileReader();

	reader.addEventListener("load", function () {
		byId("imgPreview").src = reader.result;
		
	}, false);

	if (file) {
		reader.readAsDataURL(file);
	}
}

function loadPreviewBG () {
	hasImageBGChanged=true;
	var file=byId("imageFileApiBG").files[0];;
	var reader  = new FileReader();

	reader.addEventListener("load", function () {
		byId("imgPreviewBG").src = reader.result;
		
	}, false);

	if (file) {
		reader.readAsDataURL(file);
	}
}

function deleteBG () {
	hasImageBGChanged=true;
	byId("imageFileApiBG").value = "";
	byId("imgPreviewBG").src = "";
	hasImageBG=false;
}

function imageSelectedAnnule() {
	hideId("divChoixImage");
	showId("divSaisieEntite");
}

function checkCarValide () {
	let inp=byId("inputCaract");
	if (inp.value.length>1) {
		inp.value=inp.value.slice(-1);
	}
	let c=inp.value;
	let cAut="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890#()|@[]=+$£*µù%!,?;:.<>*-";
	if (c=="") {return false}
	if (cAut.indexOf(c)<0) {
		inp.value="";
	}
}

function initListeImg () {
	tImageEnt=[];
	var canv=byId("canvTemp64");
	var ctx=canv.getContext('2d');
	var l=canv.width;
	var r=l/2;
	var r2=r*0.9;
	var x=0;
	var y=0;
	var epTrait=4;
	var r3=r2-epTrait/2;
	
	for (var e of tEnt) {
		let forme=e.forme;
		ctx.fillStyle=e.coul;
		ctx.strokeStyle=e.coul;
		ctx.lineWidth=epTrait;
		ctx.clearRect(0,0,l,l);
		var img=new Image(l,l);
		if (e.forme=="image") {
			img.src=e.png64;
		} else if (e.forme=="disque") {
			ctx.beginPath();
			ctx.arc(r,r,r2,0,Math.PI*2);
			ctx.fill();
			img.src = canv.toDataURL();
		} else if (e.forme=="point") {
			ctx.beginPath();
			ctx.arc(r,r,r2/4,0,Math.PI*2);
			ctx.fill();
			img.src = canv.toDataURL();
		} else if (forme=="cercle") {
			ctx.beginPath();
			ctx.arc(x+r,y+r,r3,0,Math.PI*2);
			ctx.stroke();
			img.src = canv.toDataURL();
		}	else if (forme=="croix") {
			ctx.beginPath();
			ctx.moveTo(x+r-r3,y+r-r3);
			ctx.lineTo(x+r+r3,y+r+r3);
			ctx.stroke();
			ctx.beginPath();
			ctx.moveTo(x+r+r3,y+r-r3);
			ctx.lineTo(x+r-r3,y+r+r3);
			ctx.stroke();
			img.src = canv.toDataURL();
		}  else if (forme=="carrep") {
			ctx.fillRect(x+r-r2,y+r-r2,r2*2,r2*2);
			img.src = canv.toDataURL();
		}	else if (forme=="carre") {
			ctx.strokeRect(x+r-r3,y+r-r3,r3*2,r3*2);
			img.src = canv.toDataURL();
		}	else if (forme=="carac") {
			let fs=Math.round(r*220)/100;
			ctx.font = fs+"px Arial";
			ctx.textAlign="center";
			ctx.fillText(e.car,x+r,y+r*1.65);
			img.src = canv.toDataURL();
		}
		tImageEnt.push (img);
	}	
}