function ajoutVarDeri () {
	var id=creeDivVar();
	var nId=id*1;
	tVar[nId].typeVar="v";
	tVar[nId].typeCalc="d";
	tVar[nId].iDeri=0;
	tVar[nId].minVal=-1;
	tVar[nId].maxVal=1;
	tVar[nId].val0=0;
	tVar[nId].nom="variable deri.#"+id;
	adapteTypeVar(id);
	closeMenu();
	restart();
}

function ajoutVarCumul () {
	var id=creeDivVar();
	var nId=id*1;
	tVar[nId].typeVar="v";
	tVar[nId].typeCalc="i";
	tVar[nId].iDeri=0;
	tVar[nId].minVal=-100;
	tVar[nId].maxVal=100;
	tVar[nId].nom="variable cumu.#"+id;
	updateVar(id);
	closeMenu();
	restart();
}

function creeLienDeri (id1,id2) {
	supprLiensVers (id2);
	var idLienCree=creeLien (id1, id2,"333333");
	tLien[idLienCree*1].typeRel="der";	
	tVar[id2*1].iDeri=id1;
}

function calcdydt () {
	for (var i=1;i<tVar.length;i++) {
		var v=tVar[i];
		var id=to2digits(i);
		if (!v.suppr) {
			var va=v.val;
			if (v.nullVal) {va=0;}
			tdydt[i]=(va-tOldVal[i])*1000/deltaT;
			tOldVal[i]=va;
			integy[i]+=va/1000*deltaT;
		}
	}
}

function updateListeVarDeri () {
	var nId=idVarEnEdition*1;
	var sel=byId("select_var_deri");
	// on vide
	for(var i = sel.options.length - 1 ; i >= 0 ; i--)
    {
        sel.remove(i);
    }
	// on cree
	for (var i=1;i<tVar.length;i++) {
		var v=tVar[i];
		var opt = document.createElement("option");
		if ((!v.suppr)&&(i!=nId)) {
			if ((v.typeVar=="c")||(v.typeVar=="d")||(v.typeVar=="n")||(v.typeVar=="v")) {
				opt.text = v.nom;
				opt.value= i;
				sel.add(opt);
			}
		}
	}
}


function updateAllVarDeri () {
	for (var j=1;j<tVar.length;j++) {
		updateDeri (j);
	}
}

function updateDeri (nId) {
	var v=tVar[nId];
	if (v.typeVar!="v") {return false;}
	if (!v.actif) {return false;}
	if (nId==modifyingVar) {return false;}
	if (iDeri<=0) {return false;}
	if (v.nullVal) {v.val=0;return false;}

	var iDeri=v.iDeri*1;
	if (v.typeCalc=="d") {v.val=tdydt[iDeri]*1;}
	else {v.val=integy[iDeri]*1;}
	checkRange(nId);
}