var tg=new Array();
var ldg,hdg,lde,hde;
var ctGraph,ctEffet;

tg[0]={};
var nbMaxVal=2000;
var ltGraph=10*1000/deltaT;


function creeGraph (id) {
	var nId=id*1;
	tg[nId]=new Object ();
	tg[nId].graph=new Array();
	eraseGraph (id);
}

function eraseGraph (id) {
	var nId=id*1;
	for (var i=0;i<nbMaxVal;i++) {
		tg[nId].graph[i]=0;
	}	
}

function initDivGraph () {
	var canvGraph=byId("canvGraph");
	ctGraph=canvGraph.getContext('2d');
	var divGraph=byId("divGraph");
	var rect=divGraph.getBoundingClientRect();
	hdg=rect.height;
	ldg=rect.width;
	canvGraph.width=ldg;
	canvGraph.height=hdg;
}
	
function initDivGraphEffet () {
	var canvEffet=byId("canvEffet");
	ctEffet=canvEffet.getContext('2d');
	var divEffet=byId("div_canv_effet");
	var rect=divEffet.getBoundingClientRect();
	hde=rect.height;
	lde=rect.width;
	canvEffet.width=lde;
	canvEffet.height=hde;

}

function traceEffet () {
	var nId=idLienEnEdition*1;
	var lien=tLien[nId];
	var idV1=lien.idV1;
	var v1=tVar[idV1*1];
	var margeX=lde*0.15;
	var margeY=hde*0.15;
	var lg=lde-margeX*2;
	var hg=hde-margeY*2;
	var formule=byId("label_formule").innerHTML;
	var seuilneg=byId("check_neg_seuil").checked;
	var seuil=byId("input_seuil").value*1;
	var selType=byId("lien_select_type").value;	
	
	var lien2=lien;
	lien2.formule=formule;
	lien2.seuilneg=seuilneg;
	lien2.seuil=seuil*1;
	var xMin=v1.minVal*1;
	var xMax=v1.maxVal*1;
	var ty=new Array();
	var tx=new Array();
	for (var i=0;i<100;i++) {
		var x=xMin+(xMax-xMin)*i/99;
		tx[i]=x;
		ty[i]=calcValEffet(lien2,x);
		//console.log(x+" "+ty[i]);
	}
	var yMin=Math.min(...ty);
	var yMax=Math.max(...ty);
	//console.log ("maxmin"+yMin+" "+yMax);
	
	// tracé
	ctEffet.fillStyle="white";
	ctEffet.fillRect (0,0,lde,hde);
	ctEffet.strokeStyle="black";
	ctEffet.beginPath();
	for (var i=0;i<100;i++) {
		var x=i*lg/99+margeX;
		var y=(hde-margeY)-(ty[i]-yMin)/(yMax-yMin)*hg;
		//console.log (x+" "+y);
		if (i==0) {ctEffet.moveTo(x,y);}
		else {ctEffet.lineTo(x,y);}		
		if (i==0) {var ygDebut=y;}
		if (i==99) {var ygFin=y;}
	}
	ctEffet.stroke();
	
	// axes 0
	ctEffet.strokeStyle="red";
	if ((xMin<=0)&&(xMax>=0)) {
		var x0=-xMin/(xMax-xMin)*lg;
		x0+=margeX;
		ctEffet.beginPath();
		ctEffet.moveTo(x0,0);
		ctEffet.lineTo(x0,hde);
		ctEffet.stroke();
	}
	if ((yMin<=0)&&(yMax>=0)) {
		var y0=-yMin/(yMax-yMin)*hg;
		y0=(hde-margeY)-y0;
		ctEffet.beginPath();
		ctEffet.moveTo(0,y0);
		ctEffet.lineTo(lde,y0);
		ctEffet.stroke();
	}
	
	var fs=Math.round(hde/3)/10;
	ctEffet.font=fs+"px Arial";
	ctEffet.textAlign="left";
	ctEffet.fillStyle="black";
	
	// graduations x
	ctEffet.strokeStyle="rgba(0,127,0,0.25)";
	var gra=getValGradu(xMin,xMax);

	var xMinGra=Math.ceil(xMin/gra)*gra;
	for (var i=xMinGra;i<=xMax;i+=gra) {
		var x=(i-xMin)/(xMax-xMin)*lg+margeX;
		ctEffet.beginPath();
		ctEffet.moveTo(x,margeY);
		ctEffet.lineTo(x,margeY+hg);
		ctEffet.stroke();
		var t=sigFigs(i,3);
		if (selType=="aug") {
			ctEffet.fillText (t,x,margeY+hg+fs*1);
		} else {
			ctEffet.fillText (t,x,margeY-fs*0.5);
		}
	}
	
	// graduations y
	ctEffet.textAlign="right";
	ctEffet.strokeStyle="rgba(0,127,0,0.25)";
	var gra=getValGradu(yMin,yMax);

	var yMinGra=Math.ceil(yMin/gra)*gra;
	
	for (var i=yMinGra;i<=yMax;i+=gra) {
		var y=(i-yMin)/(yMax-yMin)*hg;
		y=hg+margeY-y;
		ctEffet.beginPath();
		ctEffet.moveTo(margeX,y);
		ctEffet.lineTo(margeX+lg,y);
		ctEffet.stroke();
		var t=sigFigs(i,3);
		ctEffet.fillText (t,margeX+-fs*0.5,y+fs*0.3);
	}
	
	// légendes
	ctEffet.textAlign="left";
	ctEffet.fillStyle="black";
	
	
	var t=sigFigs(yMax,3);
	if (selType=="dim") {
		t=sigFigs(yMin,3);
	}
	ctEffet.fillText (t,margeX+lg+fs*0.8,ygFin+fs*0.3);
	
	var t=sigFigs(xMax,3);
	ctEffet.textAlign="center";
	if (selType=="aug") {
		ctEffet.fillText (t,margeX+lg,ygFin-fs*1.2);
	} else {
		ctEffet.fillText (t,margeX+lg,ygFin+fs*1);
	}

}

function changeIntervalle (sender) {
	var v=sender.value;
	ltGraph=Math.round(v*1000/deltaT);
}

function traceGraph () {
	var iDebut=iTemps-ltGraph;
	var margey=hdg*0.05;
	if (iDebut<0) {iDebut=0;}
	
	ctGraph.fillStyle="#F0F0F0";
	ctGraph.fillRect(0,0,ldg,hdg);
	ctGraph.fillStyle="#FFFFFF";
	ctGraph.fillRect(0,margey,ldg,hdg*0.9);
	var x,y,v,vrel,va,ii
	
	
	
	for (var j=1;j<tVar.length;j++) {
		va=tVar[j];
		if ((va.actif)&&(va.affGraph)) {
			ampli=va.maxVal-va.minVal;
			ctGraph.strokeStyle="#"+va.coul;
			ctGraph.beginPath();
			
			for (var i=iDebut;i<=iTemps;i++) {
				ii=i%nbMaxVal;
				v=tg[j].graph[ii];
				x=(i-iDebut)*ldg/ltGraph;
				vrel=(v-va.minVal)/ampli;
				y=hdg-vrel*hdg*0.9-margey;
				//console.log (x+" "+y+" "+vrel);
				if (i==iDebut) {ctGraph.moveTo(x,y);} 
				else {ctGraph.lineTo(x,y);}
			}
			ctGraph.stroke();
		}
	}
	
}

function getValGradu (xmin,xmax) {
	var v=xmax-xmin;
	var l1=Math.log10(v);
	var l2=Math.floor(l1);
	var g=Math.pow(10,l2-1);
	
	if ((l1-l2)>0.77) {
		g=g*10;
	}
	else if ((l1-l2)>0.31) {
		g=g*5;
	} 
	else if ((l1-l2)>0) {
		g=g*2;
	}
	
	return g;
}

function maximizeGraph () {
	hideId("bouton_graph");
	showId("div_conteneur_graph");
	var divConteneur=byId("div_conteneur_graph");
	divConteneur.style.width="100%";
	divConteneur.style.height="100%";
	divConteneur.style.right="0em";
	divConteneur.style.bottom="0em";
	
	initDivGraph();
	traceGraph();
	
	showId("div-but-mediumize");
	hideId("div-but-maximize");
	hideId("div-but-minimize");
}

function minimizeGraph () {
	showId("bouton_graph");
	hideId("div_conteneur_graph");
}

function mediumizeGraph () {
	hideId("bouton_graph");
	showId("div_conteneur_graph");
	var divConteneur=byId("div_conteneur_graph");
	divConteneur.style.width="27em";
	divConteneur.style.height="14em";
	divConteneur.style.right="1em";
	divConteneur.style.bottom="1.2em";
	
	initDivGraph();
	traceGraph();
	
	hideId("div-but-mediumize");
	showId("div-but-maximize");
	showId("div-but-minimize");
}