var version="1.5.7";
var lEcran,hEcran;
var menuVisible=false;
var menuAjoutVisible=false;
var originalAddMenu;
var nomModele="";
var auteurs="";

function cacheSplash() {
	hideId("div_splash");
}


function updateTitre () {
	var titre="";
	if (nomModele!="") {titre+="<h2>"+nomModele+"</h2>"} else {titre+="<h2>(modèle sans nom)</h2>"}
	if (auteurs!="") {titre+="<h3>"+auteurs+"</h3>"} 
	divTitre.innerHTML=titre;
}

function cancelEditor () {
	hideId("div_editor");
	hideId("div_editor_lien");
	hideId("div_editor_txt");
	hideId("div_editor_para");
}

function openParametersAll () {
	closeMenu();
	byId ("inputNomModele").value=nomModele;
	byId ("inputAuteurModele").value=auteurs;
	byId ("inputNbSig").value=nbSig;
	showId("div_editor_para");
}

function fermeEditorPara () {
	nomModele=byId ("inputNomModele").value;
	auteurs=byId ("inputAuteurModele").value;
	nbSig=byId ("inputNbSig").value*1;
	
	hideId("div_editor_para");
	updateAllSVG ();
	updateAllVarCalc();
	updateAllPheno();
	updateAllVar();
	updateTitre();
}


function menu() {
	closeMenu();
	menuVisible=!menuVisible;
	if (menuVisible) {
		showId("div_menu");
		byId("bouton_menu").style.opacity="0.4";
	} 
}

function menuAjout() {
	closeMenu();
	menuAjoutVisible=!menuAjoutVisible;
	if (menuAjoutVisible) {
		showId("div_menu_ajout");
		byId("bouton_ajout").style.opacity="0.4";
	} 
}

function ouvreMenuVar() {
	showId("div_menu_ajout2");
}

function fermeMenuVar () {
	hideId("div_menu_ajout2");
}

function closeMenu() {
	menuVisible=false;
	hideId("div_menu");
	byId("bouton_menu").style.opacity="1";
	menuAjoutVisible=false;
	hideId("div_menu_ajout");
	fermeMenuVar ();
	byId("bouton_ajout").style.opacity="1";	
}

function redim () {
	lEcran=document.body.clientWidth;
	hEcran=document.body.clientHeight;
	var fs=Math.round(hEcran*19)/1000;
	document.body.style.fontSize=fs+"px";
	checkZoom();
	updateAllSVG();
	initDivGraph();
	initDivGraphEffet();
	traceGraph();
}

function restart() {
	for (var i=1;i<tVar.length;i++) {
		tVar[i].val=tVar[i].val0*1;
		tOldVal[i]=tVar[i].val;
		tdydt[i]=0;
		iTemps=0;
		integy[i]=0;
	}
	updateAllPheno();
	updateAllVar();
	updateAllVarCalc();
	closeMenu();
}

function confirmExit() {
    return "You have attempted to leave this page. Are you sure?";
}
	

function go() {
	show(document.body);
	
	//window.onbeforeunload = confirmExit;
   
	originalAddMenu=byId("div_add_template").innerHTML; // on sauvegarde le menu d'origine
	checkDemo();
	updateVersion();
	redim();
	
	creePath ("00","000000",true);
	
	byId('fileinput').addEventListener('change', readSingleFile, false);
	byId('fileinputTemplate').addEventListener('change', readSingleFileTemplate, false);
	
	//loadDemo(testDeri);
	
	svgBringToFront (byId("svgPath"));
	mediumizeGraph ();
	redim();
	animate();
}



function eraseAll () {
	closeMenu();
	if ((tVar.length>1)||(tTxt.length>1)) {
		
		
		
		swal({
		  title: 'Le modèle actuel va être fermé',
		  text: "Le modèle actuel va être effacé. Etes vous sûr de vouloir poursuivre ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			eraseAllStep2 ();
		  } else {
			return false;
		  }
		})
	} else {
		eraseAllStep2 ();
	}
}

function eraseAllStep2 () {
	auteurs="";
	nbSig=5;
	nomModele="";
	for (var i=1;i<tVar.length;i++) {
		supprVar(to2digits(i));
		tVar[i]={};
	}
	for (var i=1;i<tLien.length;i++) {
		tLien[i]={};
	}
	for (var i=1;i<tTxt.length;i++) {
		supprTxt (to2digits(i));
	}
	for (var i=1;i<tTxt.length;i++) {
		tTxt[i]={};
	}
	updateTitre();
	destroyAll ();
	checkZoom();
	return true;
}

function destroyAll () {
	var divCtn=byId("div_conteneur_modele");
	var svgpath=byId("svgPath");
	for (var i=1;i<tLien.length;i++) {
		var id=to2digits(i);
		var courbe=byId("path"+id);
		svgpath.removeChild(courbe);
		var ctrc=byId("ctr"+id);
		divCtn.removeChild(ctrc);
	}
	
	for (var i=1;i<tVar.length;i++) {
		var id=to2digits(i);
		var divVar=byId("var"+id);
		divCtn.removeChild(divVar);
	}
	
	for (var i=1;i<tTxt.length;i++) {
		var id=to2digits(i);
		var divTxt=byId("txt"+id);
		divCtn.removeChild(divTxt);
	}
			
	tVar.length=1;
	tLien.length=1;
	tTxt.length=1;		
}


function dragElement(elmnt) {
  var pos1 = 0, pos2 = 0, pos3 = 0, pos4 = 0;
  if (byId(elmnt.id + "header")) {
    /* if present, the header is where you move the DIV from:*/
    byId(elmnt.id + "header").onmousedown = dragMouseDown;
  } else {
    /* otherwise, move the DIV from anywhere inside the DIV:*/
    elmnt.onmousedown = dragMouseDown;
  }

  function dragMouseDown(e) {
    e = e || window.event;
    // get the mouse cursor position at startup:
    pos3 = e.clientX;
    pos4 = e.clientY;
    document.onmouseup = closeDragElement;
    // call a function whenever the cursor moves:
    document.onmousemove = elementDrag;
  }

  function elementDrag(e) {
    e = e || window.event;
	var nomEl=elmnt.id.substr(0,3);
	var id=elmnt.id.substr(3,2);
	var nId=id*1;
	
    // calculate the new cursor position:
    pos1 = pos3 - e.clientX;
    pos2 = pos4 - e.clientY;
    pos3 = e.clientX;
    pos4 = e.clientY;
    // set the element's new position:
	elmnt.style.top = (elmnt.offsetTop - pos2) + "px";
    elmnt.style.left = (elmnt.offsetLeft - pos1) + "px";
	
	// anti débordement
	var r=elmnt.getBoundingClientRect();
	if (r.top<0) {elmnt.style.top="0px";} else if (r.bottom>hEcran) {elmnt.style.top=(hEcran-r.height)+"px";}
	if (r.left<0) {elmnt.style.left="0px";} else if (r.right>lEcran) {elmnt.style.left=(lEcran-r.width)+"px";}
	
	if (nomEl=="ctr") {
		updateSVG (id);
	} else 
	if (nomEl=="var") {
		updateSVGenLienAvec (id);
	}
  }

  function closeDragElement() {
    /* stop moving when mouse button is released:*/
	document.onmouseup = null;
    document.onmousemove = null;	
	var r=elmnt.getBoundingClientRect();
	var nomEl=elmnt.id.substr(0,3);
	var nId=elmnt.id.substr(3,2);
	
	var parentFontSize = parseFloat(window.getComputedStyle(elmnt, null).fontSize, 10);
	    
	// on convertit la position en em 
	// si <0 on change
	
	if (nomEl=="ctr") {
		//il faut prendre en compte la rotation qui décale
		var xCentre=r.left+r.width/2;
		var yCentre=r.top+r.height/2;
		var r00=byId("ctr00").getBoundingClientRect();
		var cle=xCentre-r00.width/2;
		var cto=yCentre-r00.height/2;
				 
		elmnt.style.top =  cto/parentFontSize  + "em";
		elmnt.style.left = cle/parentFontSize + "em";
		updateSVG (nId);
	} else if (nomEl=="var") {
		elmnt.style.top =  r.top/parentFontSize  + "em";
		elmnt.style.left = r.left/parentFontSize + "em";
		updateSVGenLienAvec (nId);
	}
  }
 
}

function updateVersion () {
	var lastMod=new Date(document.lastModified);
	var jour=to2digits(lastMod.getDate()*1);
	var an=lastMod.getFullYear();
	var mois=to2digits(lastMod.getMonth()*1+1);
	var lastDate=jour+"/"+mois+"/"+an;
	byId("label_version").innerHTML=version+" (dernière modification "+lastDate+")";
}

function goToMainScreen () {
	closeMenu();
	if ((tVar.length<=1)&&(tTxt.length<=1)) {
		window.location.href = '../index.htm';	
		return false;
	} 
	
	swal({
		  title: 'Le modèle actuel va être fermé',
		  text: "Retourner à l'écran d'accueil va entraîner la fermeture de ce modèle. Etes vous sûr de vouloir poursuivre ?",
		  type: 'warning',
		  showCancelButton: true,
		  confirmButtonColor: '#3085d6',
		  cancelButtonColor: '#d33',
		  confirmButtonText: 'Oui',
		  cancelButtonText: 'Non',
		  confirmButtonClass: 'btn btn-success',
		  cancelButtonClass: 'btn btn-danger',
		  buttonsStyling: true,
		  reverseButtons: false
		}).then((result) => {
		  if (result.value) {
			window.location.href = '../index.htm';	
			return false;
		  } else {
			return false;
		  }
		})
	
}